"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAssociatedTokenAccountIdempotentInstruction = void 0;
var mango_client_1 = require("@blockworks-foundation/mango-client");
var anchor_1 = require("@project-serum/anchor");
var web3_js_1 = require("@solana/web3.js");
var spl_token_1 = require("@solana/spl-token");
var client_1 = require("./client");
var bn_js_1 = __importDefault(require("bn.js"));
var fs_1 = __importDefault(require("fs"));
/// Env
var CLUSTER_URL = process.env.CLUSTER_URL_OVERRIDE || process.env.MB_CLUSTER_URL;
var PAYER_KEYPAIR = process.env.PAYER_KEYPAIR_OVERRIDE || process.env.MB_PAYER_KEYPAIR;
var GROUP_NUM = Number(process.env.GROUP_NUM || 5);
var CLUSTER = process.env.CLUSTER_OVERRIDE || "mainnet-beta";
var MANGO_V3_CLUSTER = process.env.MANGO_V3_CLUSTER_OVERRIDE || "mainnet";
var MANGO_V3_GROUP_NAME = process.env.MANGO_V3_GROUP_NAME_OVERRIDE || "mainnet.1";
var options = anchor_1.AnchorProvider.defaultOptions();
var connection = new web3_js_1.Connection(CLUSTER_URL, options);
// Mango v3 client setup
var config = mango_client_1.Config.ids();
var groupIds = config.getGroup(MANGO_V3_CLUSTER, MANGO_V3_GROUP_NAME);
if (!groupIds) {
    throw new Error("Group ".concat(MANGO_V3_GROUP_NAME, " not found"));
}
var mangoProgramId = groupIds.mangoProgramId;
var mangoGroupKey = groupIds.publicKey;
var mangoV3Client = new mango_client_1.MangoClient(connection, mangoProgramId);
Error.stackTraceLimit = 1000;
function createAssociatedTokenAccountIdempotentInstruction(payer, owner, mint, ata) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new web3_js_1.TransactionInstruction({
                    keys: [
                        { pubkey: payer, isSigner: true, isWritable: true },
                        { pubkey: ata, isSigner: false, isWritable: true },
                        { pubkey: owner, isSigner: false, isWritable: false },
                        { pubkey: mint, isSigner: false, isWritable: false },
                        {
                            pubkey: web3_js_1.SystemProgram.programId,
                            isSigner: false,
                            isWritable: false,
                        },
                        { pubkey: spl_token_1.TOKEN_PROGRAM_ID, isSigner: false, isWritable: false },
                    ],
                    programId: spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID,
                    data: Buffer.from([0x1]),
                })];
        });
    });
}
exports.createAssociatedTokenAccountIdempotentInstruction = createAssociatedTokenAccountIdempotentInstruction;
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var sig, admin, adminWallet, provider, mangoV3ReimbursementClient, sig_1, group, _loop_1, _a, _b, _c, index, tokenInfo, e_1_1, reimbursementAccount, rows, ra;
        var e_1, _d;
        var _this = this;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    admin = web3_js_1.Keypair.fromSecretKey(Buffer.from(JSON.parse(fs_1.default.readFileSync(PAYER_KEYPAIR, "utf-8"))));
                    adminWallet = new anchor_1.Wallet(admin);
                    provider = new anchor_1.AnchorProvider(connection, adminWallet, options);
                    mangoV3ReimbursementClient = new client_1.MangoV3ReimbursementClient(provider);
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.account.group.all()];
                case 1:
                    if (!!(_e.sent()).find(function (group) { return group.account.groupNum === GROUP_NUM; })) return [3 /*break*/, 3];
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.methods
                            .createGroup(GROUP_NUM, new web3_js_1.PublicKey("mdcXrm2NkzXYvHNcKXzCLXT58R4UN8Rzd1uzD4h8338"), 1)
                            .accounts({
                            table: new web3_js_1.PublicKey("tabXVjdYVYGbT2SmZbgaaXm1QBYArbDio8BMCZxgrU4"),
                            payer: mangoV3ReimbursementClient.program.provider
                                .wallet.publicKey,
                            authority: mangoV3ReimbursementClient.program.provider.wallet.publicKey,
                        })
                            .rpc({ skipPreflight: true })];
                case 2:
                    sig_1 = _e.sent();
                    console.log("created group, sig https://explorer.solana.com/tx/".concat(sig_1 + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                    _e.label = 3;
                case 3: return [4 /*yield*/, mangoV3ReimbursementClient.program.account.group.all()];
                case 4:
                    group = (_e.sent()).find(function (group) { return group.account.groupNum === GROUP_NUM; });
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.account.group.all()];
                case 5:
                    // // Edit group, set new table
                    // await mangoV3ReimbursementClient.program.methods
                    //   .editGroup(new PublicKey("tabXVjdYVYGbT2SmZbgaaXm1QBYArbDio8BMCZxgrU4"))
                    //   .accounts({
                    //     group: group?.publicKey,
                    //     authority: (mangoV3ReimbursementClient.program.provider as AnchorProvider)
                    //       .wallet.publicKey,
                    //   })
                    //   .rpc();
                    // Reload group
                    group = (_e.sent()).find(function (group) { return group.account.groupNum === GROUP_NUM; });
                    _loop_1 = function (index, tokenInfo) {
                        var bU64, claimMint, claimTransferTokenAccount, sig_2, _f, _g;
                        var _h;
                        return __generator(this, function (_j) {
                            switch (_j.label) {
                                case 0:
                                    // If token for index is set in v3
                                    if (tokenInfo.mint.equals(web3_js_1.PublicKey.default)) {
                                        return [2 /*return*/, "continue"];
                                    }
                                    // If token is still active in v3
                                    if (tokenInfo.oracleInactive === true) {
                                        return [2 /*return*/, "continue"];
                                    }
                                    // If vault has not already been created
                                    if (!(group === null || group === void 0 ? void 0 : group.account.vaults[index].equals(web3_js_1.PublicKey.default))) {
                                        return [2 /*return*/, "continue"];
                                    }
                                    bU64 = Buffer.alloc(8);
                                    bU64.writeBigUInt64LE(BigInt(index));
                                    return [4 /*yield*/, web3_js_1.PublicKey.findProgramAddress([Buffer.from("Mint"), group === null || group === void 0 ? void 0 : group.publicKey.toBuffer(), bU64], mangoV3ReimbursementClient.program.programId)];
                                case 1:
                                    claimMint = (_j.sent())[0];
                                    return [4 /*yield*/, (0, spl_token_1.getAssociatedTokenAddress)(claimMint, group.account.claimTransferDestination)];
                                case 2:
                                    claimTransferTokenAccount = _j.sent();
                                    _g = (_f = mangoV3ReimbursementClient.program.methods
                                        .createVault(new bn_js_1.default(index)))
                                        .accounts;
                                    _h = {};
                                    return [4 /*yield*/, (0, spl_token_1.getAssociatedTokenAddress)(tokenInfo.mint, group.publicKey, true)];
                                case 3: return [4 /*yield*/, _g.apply(_f, [(_h.vault = _j.sent(),
                                            _h.group = group.publicKey,
                                            _h.mint = tokenInfo.mint,
                                            _h.claimTransferTokenAccount = claimTransferTokenAccount,
                                            _h.claimTransferDestination = group.account.claimTransferDestination,
                                            _h.payer = mangoV3ReimbursementClient.program.provider
                                                .wallet.publicKey,
                                            _h)])
                                        .rpc()];
                                case 4:
                                    sig_2 = _j.sent();
                                    console.log("setup vault for ".concat(groupIds === null || groupIds === void 0 ? void 0 : groupIds.tokens.filter(function (token) {
                                        return token.mintKey.equals(tokenInfo.mint);
                                    })[0].symbol, " at index ").concat(index, " , sig https://explorer.solana.com/tx/").concat(sig_2 + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                                    return [2 /*return*/];
                            }
                        });
                    };
                    _e.label = 6;
                case 6:
                    _e.trys.push([6, 12, 13, 14]);
                    return [4 /*yield*/, mangoV3Client.getMangoGroup(mangoGroupKey)];
                case 7:
                    _a = __values.apply(void 0, [(_e.sent()).tokens.entries()]), _b = _a.next();
                    _e.label = 8;
                case 8:
                    if (!!_b.done) return [3 /*break*/, 11];
                    _c = __read(_b.value, 2), index = _c[0], tokenInfo = _c[1];
                    return [5 /*yield**/, _loop_1(index, tokenInfo)];
                case 9:
                    _e.sent();
                    _e.label = 10;
                case 10:
                    _b = _a.next();
                    return [3 /*break*/, 8];
                case 11: return [3 /*break*/, 14];
                case 12:
                    e_1_1 = _e.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 14];
                case 13:
                    try {
                        if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 14:
                    // Top up vaults
                    groupIds === null || groupIds === void 0 ? void 0 : groupIds.tokens.filter(function (token) {
                        return token.symbol.includes("BTC") ||
                            token.symbol.includes("ETH") ||
                            token.symbol.includes("SOL") ||
                            token.symbol.includes("USDC");
                    }).forEach(function (token) { return __awaiter(_this, void 0, void 0, function () {
                        var i, latestBlockhash, tx, _a, _b, _c, _d, sig;
                        return __generator(this, function (_e) {
                            switch (_e.label) {
                                case 0:
                                    i = group === null || group === void 0 ? void 0 : group.account.mints.findIndex(function (mint) {
                                        return mint.equals(token.mintKey);
                                    });
                                    if (!i) {
                                        throw new Error("Token not found!");
                                    }
                                    return [4 /*yield*/, connection.getLatestBlockhash()];
                                case 1:
                                    latestBlockhash = _e.sent();
                                    tx = new web3_js_1.Transaction({
                                        blockhash: latestBlockhash.blockhash,
                                        lastValidBlockHeight: latestBlockhash.lastValidBlockHeight,
                                    });
                                    _b = (_a = tx).add;
                                    _c = spl_token_1.createTransferCheckedInstruction;
                                    return [4 /*yield*/, (0, spl_token_1.getAssociatedTokenAddress)(group === null || group === void 0 ? void 0 : group.account.mints[i], admin.publicKey)];
                                case 2:
                                    _b.apply(_a, [_c.apply(void 0, [_e.sent(), group === null || group === void 0 ? void 0 : group.account.mints[i],
                                            group === null || group === void 0 ? void 0 : group.account.vaults[i],
                                            admin.publicKey,
                                            10,
                                            token.decimals])]);
                                    _d = tx;
                                    return [4 /*yield*/, connection.getLatestBlockhash()];
                                case 3: return [4 /*yield*/, (_e.sent()).blockhash];
                                case 4:
                                    _d.recentBlockhash = _e.sent();
                                    tx.sign(admin);
                                    return [4 /*yield*/, connection.sendRawTransaction(tx.serialize(), {
                                            skipPreflight: true,
                                        })];
                                case 5:
                                    sig = _e.sent();
                                    console.log("topped up ".concat(token.symbol, " vault ").concat(group === null || group === void 0 ? void 0 : group.account.vaults[i], ", sig https://explorer.solana.com/tx/").concat(sig + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.account.group.all()];
                case 15:
                    // Reload group
                    group = (_e.sent()).find(function (group) { return group.account.groupNum === GROUP_NUM; });
                    if (!((group === null || group === void 0 ? void 0 : group.account.reimbursementStarted) === 0)) return [3 /*break*/, 17];
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.methods
                            .startReimbursement()
                            .accounts({
                            group: group.publicKey,
                            authority: mangoV3ReimbursementClient.program.provider.wallet.publicKey,
                        })
                            .rpc()];
                case 16:
                    sig = _e.sent();
                    console.log("start reimbursement, sig https://explorer.solana.com/tx/".concat(sig + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                    _e.label = 17;
                case 17: return [4 /*yield*/, web3_js_1.PublicKey.findProgramAddress([
                        Buffer.from("ReimbursementAccount"),
                        group === null || group === void 0 ? void 0 : group.publicKey.toBuffer(),
                        admin.publicKey.toBuffer(),
                    ], mangoV3ReimbursementClient.program.programId)];
                case 18:
                    reimbursementAccount = (_e.sent())[0];
                    return [4 /*yield*/, connection.getAccountInfo(reimbursementAccount)];
                case 19:
                    if (!!(_e.sent())) return [3 /*break*/, 21];
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.methods
                            .createReimbursementAccount()
                            .accounts({
                            group: group.publicKey,
                            mangoAccountOwner: admin.publicKey,
                            payer: mangoV3ReimbursementClient.program.provider
                                .wallet.publicKey,
                        })
                            .rpc({ skipPreflight: true })];
                case 20:
                    sig = _e.sent();
                    console.log("created reimbursement account for ".concat(admin.publicKey, ", sig https://explorer.solana.com/tx/").concat(sig + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                    _e.label = 21;
                case 21: return [4 /*yield*/, mangoV3ReimbursementClient.decodeTable(group === null || group === void 0 ? void 0 : group.account)];
                case 22:
                    rows = _e.sent();
                    rows.find(function (row) { return row.owner.equals(admin.publicKey); }).balances;
                    return [4 /*yield*/, mangoV3ReimbursementClient.program.account.reimbursementAccount.fetch(reimbursementAccount)];
                case 23:
                    ra = _e.sent();
                    mangoV3ReimbursementClient.reimbursed(ra, 0);
                    // Reimburse
                    groupIds === null || groupIds === void 0 ? void 0 : groupIds.tokens.filter(function (token) {
                        return token.symbol.includes("BTC") ||
                            token.symbol.includes("ETH") ||
                            token.symbol.includes("SOL") ||
                            token.symbol.includes("USDC");
                    }).forEach(function (token) { return __awaiter(_this, void 0, void 0, function () {
                        var i, _a, _b;
                        var _c;
                        return __generator(this, function (_d) {
                            switch (_d.label) {
                                case 0:
                                    i = group === null || group === void 0 ? void 0 : group.account.mints.findIndex(function (mint) {
                                        return mint.equals(token.mintKey);
                                    });
                                    if (!i) {
                                        throw new Error("Token not found!");
                                    }
                                    _b = (_a = mangoV3ReimbursementClient.program.methods
                                        .reimburse(new bn_js_1.default(i), new bn_js_1.default(0), true))
                                        .accounts;
                                    _c = {
                                        group: group.publicKey,
                                        vault: group === null || group === void 0 ? void 0 : group.account.vaults[i]
                                    };
                                    return [4 /*yield*/, (0, spl_token_1.getAssociatedTokenAddress)(group === null || group === void 0 ? void 0 : group.account.mints[i], admin.publicKey)];
                                case 1:
                                    _c.tokenAccount = _d.sent(),
                                        _c.reimbursementAccount = reimbursementAccount,
                                        _c.claimMint = group === null || group === void 0 ? void 0 : group.account.claimMints[i];
                                    return [4 /*yield*/, (0, spl_token_1.getAssociatedTokenAddress)(group === null || group === void 0 ? void 0 : group.account.claimMints[i], group === null || group === void 0 ? void 0 : group.account.claimTransferDestination)];
                                case 2: return [4 /*yield*/, _b.apply(_a, [(_c.claimMintTokenAccount = _d.sent(),
                                            _c.mangoAccountOwner = admin.publicKey,
                                            _c.table = group === null || group === void 0 ? void 0 : group.account.table,
                                            _c)])
                                        .rpc({ skipPreflight: true })];
                                case 3:
                                    sig = _d.sent();
                                    console.log("reimbursing ".concat(admin.publicKey, ", sig https://explorer.solana.com/tx/").concat(sig + (CLUSTER === "devnet" ? "?cluster=devnet" : "")));
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    return [2 /*return*/];
            }
        });
    });
}
main();
